var MyslDenik = angular.module('MyslDenik', ['pdfjsViewer', 'ngRoute', 'ngCookies', 'ngFileUpload', 'ds.clock', 'base64']);

MyslDenik.constant('appName', 'Deník Mysliveckého Hospodáře');

MyslDenik.constant('urls', function(urlName) {
  var urlToReturn;
  var urls = {'info': 'Užitečné informace',
              'settings': 'Nastavení',
              'shooting': 'Honitba',
              'evidence': 'Evidence',
              'plans': 'Plánování'};

  angular.forEach(urls, function(value, key) {
    if (urlName == key) {
      urlToReturn = value;
      return;
    }
  });

  return urlToReturn;
});

MyslDenik.constant('menuNames', function(menuName) {
  var menuNameToReturn;
  var menu = {'info': 'Užitečné informace',
              'settings': 'Nastavení',
              'shooting': 'Honitba',
              'evidence': 'Evidence',
              'plans': 'Plánování'};

  angular.forEach(menu, function(value, key) {
    if (menuName == key) {
      menuNameToReturn = value;
      return;
    }
  });

  return menuNameToReturn;
});

MyslDenik.constant('submenuNames', function(submenuName) {
  var menuNameToReturn;
  var menu = {'plansDeer': 'Plán chovu a lovu pro zvěř spárkatou',
              'plansSmall': 'Plán chovu a lovu pro zvěř drobnou',
              'plansOthers': 'Plán ostatních druhů zvěře',
              'plansCare': 'Plán péče o zvěř',
              'plansHunts': 'Plán společných lovů zvěře',
              'plansDogs': 'Plán počtu loveckých psů',
              'plansCounts': 'Výsledky sčítání zvěře',
              'plansFulfilPlans': 'Měšíční hlášení o plnění plánu',
              'members': 'Členové sdružení',
              'infoInfo': 'Důležité informace',
              'kynology': 'Kynologie',
              'shootingNew': 'Přidat honitbu',
              'shootingMap': 'Mapa honitby',
              'evidenceDamages': 'Evidence škod způsobených zvěří',
              'evidenceSingleHunts': 'Evidence ulovené zvěře lovů samostatných',
              'evidenceSharedHunts': 'Evidence ulovené zvěře lovů hromadných',
              'evidenceDiseases': 'Evidence hlášených chorob',
              'evidenceShooting': 'Evidence výživy honitby',
              'huntDates': 'Doby lovu zvěře'
              };

  angular.forEach(menu, function(value, key) {
    if (submenuName == key) {
      menuNameToReturn = value;
      return;
    }
  });

  return menuNameToReturn;
});

MyslDenik.factory('initUser', function($cookies, $rootScope) {
    return {
        init: function(user) {
          var expireDate = new Date();
          expireDate.setDate(expireDate.getDate() + 1);
          $cookies.putObject('loggedUser', {id: user.uid, name: user.displayName},
              {expires: expireDate});
          $rootScope.userName = user.displayName;
          $rootScope.activeYear = new Date().getFullYear();

          firebase.database().ref('/shootings/' + userId)
              .orderByChild('active')
              .limitToLast(1)
              .once('value')
              .then(function(snapshot) {
            if (snapshot.exists()) {
              snapshot.forEach(function(childSnapshot) {
                $rootScope.activeShooting = childSnapshot.child('name').val();
                $cookies.putObject('shooting', {name: childSnapshot.child('name').val(),
                    id: childSnapshot.key, year: new Date().getFullYear()}, {expires: expireDate});
              });
            }
          });
        }

    };
});

MyslDenik.factory('breadcrumbs', function(menuNames, submenuNames) {
  var breadcrumbs = {};

  breadcrumbs.getBreadCrumbs = function(url) {
    var urls = {'/shooting/members': menuNames('shooting') + ' -> ' + submenuNames('members'),
                '/huntDates': menuNames('info') + ' -> ' + submenuNames('huntDates'),
                '/kynology': menuNames('info') + ' -> ' + submenuNames('kynology'),
                '/shootingMap': menuNames('shooting') + ' -> ' + submenuNames('shootingMap'),
                '/shootingNew': menuNames('shooting') + ' -> ' + submenuNames('shootingNew'),
                '/planspdf/plansDeer': menuNames('plans') + ' -> ' + submenuNames('plansDeer'),
                '/planspdf/plansSmall': menuNames('plans') + ' -> ' + submenuNames('plansSmall'),
                '/planspdf/plansOthers': menuNames('plans') + ' -> ' + submenuNames('plansOthers'),
                '/planspdf/plansCare': menuNames('plans') + ' -> ' + submenuNames('plansCare'),
                '/planspdf/plansHunts': menuNames('plans') + ' -> ' + submenuNames('plansHunts'),
                '/planspdf/plansDogs': menuNames('plans') + ' -> ' + submenuNames('plansDogs'),
                '/planspdf/plansCounts': menuNames('plans') + ' -> ' + submenuNames('plansCounts'),
                '/plansFulfilPlans': menuNames('plans') + ' -> ' + submenuNames('plansFulfilPlans'),
                '/evidence/damages': menuNames('evidence') + ' -> ' + submenuNames('evidenceDamages'),
                '/evidence/singleHunts': menuNames('evidence') + ' -> ' + submenuNames('evidenceSingleHunts'),
                '/evidence/sharedHunts': menuNames('evidence') + ' -> ' + submenuNames('evidenceSharedHunts'),
                '/evidence/diseases': menuNames('evidence') + ' -> ' + submenuNames('evidenceDiseases'),
                '/evidence/shooting': menuNames('evidence') + ' -> ' + submenuNames('evidenceShooting')};

    var returnValue = '';
    angular.forEach(urls, function(value, key) {
      if (url == key) {
        returnValue = value;
        return;
      }
    });
    return returnValue;
  };

  return breadcrumbs;
});

MyslDenik.filter('trustUrl', function ($sce) {
    return function(url) {
      return $sce.trustAsResourceUrl(url);
    };
  });

MyslDenik.run(function ($rootScope, $location, $cookies, breadcrumbs) {

    var checkActualShooting = function() {
      console.log($cookies.getObject('shooting'));
      if (typeof $cookies.getObject('shooting') === 'undefined'
          && typeof $cookies.getObject('loggedUser') !== 'undefined') {
            $location.path('/shootingNew');
      }
    };

    $rootScope.$on("$locationChangeStart", function (event, next, current) {
        if ($location.path() == "/registration" || $location.path() == "/forgotpass" || $location.path() == "/") {
          $rootScope.showMenu = false;
        } else {
          $rootScope.showMenu = true;
        }

        checkActualShooting();

        if ($location.path() == "/mainView") {
          $rootScope.showBreadcrumbs = false;
        } else {
          $rootScope.showBreadcrumbs = true;
        }

        if (!$cookies.getObject('loggedUser') && $location.path() != "/registration" &&
            $location.path() != "/forgotpass" && $location.path() != "/") {
            $location.path('/');
        }

        if ($cookies.getObject('loggedUser') && ($location.path() == "/registration" ||
            $location.path() == "/forgotpass" || $location.path() == "/")) {
            $location.path('/mainView');
        }

        $rootScope.breadcrumbs = breadcrumbs.getBreadCrumbs($location.path());
    });
})

//------------------------------------------------------------------------------

MyslDenik.controller("authController", function(
    $http, $rootScope, $cookies, $scope, $location, menuNames, submenuNames,
    appName, objectFactory, $route) {

  $scope.yearToChange = $rootScope.activeYear;
  $scope.appName = appName;
  $scope.menuNames = function(menuName) {
    return menuNames(menuName);
  };

  $scope.changeYear = function() {
    $rootScope.activeYear = $scope.yearToChange;
    let expireDate = new Date();
    let name = $cookies.getObject('shooting').name;
    let id = $cookies.getObject('shooting').id;
    expireDate.setDate(expireDate.getDate() + 1);    
    $cookies.putObject('shooting', {name: name, id: id, year: $scope.yearToChange}, {expires: expireDate});
    $route.reload();    
  }

  $scope.submenuNames = function(submenuName) {
    return submenuNames(submenuName);
  }

  if (!$cookies.getObject('loggedUser')) {
    $rootScope.userName = "";
  } else {
    $rootScope.userName = $cookies.getObject('loggedUser').name;
  }

  if (!$cookies.getObject('shooting')) {
    $rootScope.activeShooting = '';
    $rootScope.activeYear = '';
  } else {
    $rootScope.activeShooting  = $cookies.getObject('shooting').name;
    $rootScope.activeYear = $cookies.getObject('shooting').year;
    console.log($rootScope.activeYear);
  }

  // $scope.$watch('userName', function() {
  //       console.log("userName changed" + $scope.userName);
  //       if($scope.loggedUser) {
  //         $location.path('/');
  //       }
  // });

  // $scope.testFactory = function() {
  //   console.log("NECO");
  //   var x = notify.addSom('AKSDJKADS');
  //   console.log(apiToken);
  //   console.log("factory: " + x);
  // };

  $scope.logout = function () {
    firebase.auth().signOut().then(function() {
      $cookies.remove('loggedUser');
      $cookies.remove('shooting');
      $location.path('/');
      $rootScope.$apply();
    }, function(error) {

    });
  };

  firebase.auth().onAuthStateChanged(function (user) {
    if (!user) {
        $cookies.remove('loggedUser');
        // $location.path('/');
        // $rootScope.$apply();
    }
  });
});
