MyslDenik.controller("damageEvidenceController", function($http, $rootScope, $scope,  $location, $cookies) {

  let userId = $cookies.getObject('loggedUser').id;
  let shootingKey;
  let mapRecords = [];
  let init = true;
  let imageIndex = undefined; 

  $scope.records = [];
  $scope.editArray = [];
  $scope.dates = []; 
  $scope.newRecord = {date: new Date(), game: '', sex: '', age: '', place: '', damage: '', note: '', image: ''};

  firebase.database().ref('/shootings/' + userId)
      .orderByChild('active')
      .limitToLast(1)
      .once('value')
      .then(function(snapshot) {
        if (snapshot.exists()) {
          snapshot.forEach(function(shooting) {
            shootingKey = shooting.key;
          });
          let ref = firebase.database().ref('evidences/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear + '/damages');
          ref.on('child_added', function(record) {
              $scope.records.push(record.val());              
              mapRecords.push(record); 
              $scope.dates.push(new Date(record.val().date));
              if (init) {                
                $scope.$apply();
              } else {
                init = true;
              }            
          });   
        }       
      });

  let prepareEditArray = function() {
    $scope.records.forEach(function(element) {
        $scope.editArray.push(false);
    }, this);
  }

  $scope.getImage = function(index) {
    if ($scope.records[index].image == '' || $scope.records[index].image == undefined) {
      return './assets/image/antlers_launcher.png';
    }
    let type = 'data:image/png;base64,';
    return type.concat($scope.records[index].image);
  }

  $scope.saveRecord = function(index) {
    imageIndex = index;
    if (!$scope.editArray[index]) {
      $scope.records[index].date = getStringDate($scope.dates[index]);
      let key = mapRecords[index].key
      firebase.database().ref().child('evidences/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear + '/damages/' + key).update($scope.records[index]);
    }
  }

  function getBase64(file) {

    console.log("JAKYE WAT<");
    var reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = function () {
      console.log(imageIndex);
      if (imageIndex == undefined) {    
        console.log(reader.result);    
        $scope.newRecord.image = reader.result.replace("data:image/png;base64,", "");
      } else {
        $scope.records[imageIndex].image = reader.result.replace("data:image/png;base64,", "");
      }
    };
    reader.onerror = function (error) {
      console.log('Error: ', error);
    };
  }

  $scope.uploadFile = function(files) {        
    console.log("WTF");
    getBase64(files[0]);
  };

  $scope.uploadNewFile = function(files) {       
    console.log("WHT"); 
    imageIndex = undefined;
    getBase64(files[0]);
  };

  $scope.getDateX = function(index) {
    return new Date($scope.records[index].date);
  }

  getStringDate = function(date) {
    let today = date;
      let dd = today.getDate();
      let mm = today.getMonth()+1; //January is 0!

      let yyyy = today.getFullYear();
      if(dd<10){
          dd='0'+dd;
      } 
      if(mm<10){
          mm='0'+mm;
      } 
      return stringDat = dd+'/'+mm+'/'+yyyy;      
  }

  $scope.getSex = function(index) {
    let sex = $scope.records[index].sex;
    switch (sex) {
      case 'male-1':
        return 'I. věk. tř.'
        break;
      case 'male-2':
        return 'II. věk. tř.'
        break;
      case 'male-3':
        return 'III. věk. tř.'
        break;
      case 'female':
        return 'Samice'
        break;
      case 'spring':
        return 'I. věk. tř.'
        break;
    
      default:
        break;
    }
  }

  $scope.saveNewRecord = function() {
    init = false;        ;
    $scope.newRecord.date = getStringDate($scope.newRecord.date);    
    firebase.database().ref('evidences/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear + '/damages').push($scope.newRecord);        
    $scope.newRecord = {date: new Date(), game: '', sex: '', age: '', place: '', damage: '', note: '', image: ''};    
  }
});
