MyslDenik.controller("homeController", function($http, $rootScope, $scope,  $location, $cookies) {

$scope.navigateTo = function(path) {
  $location.path(path);
  
}

// PDFVIew
$scope.showPdf = false;    
$scope.showLoader = true;
$scope.showPdfInfo = false;
$scope.docPdf = "";  
$scope.fileHref = "url";   
$scope.activeMonth = 1; 
$scope.monthlyPlanExists = false;
$scope.activeMonthx = 'black'; 
let userId = $cookies.getObject('loggedUser').id;    
let pdfname = "monthlyPlan";        
let storage = firebase.storage();
let storageRef = storage.ref();
let doc = '';  
let shootingKey = '';     
// let months = ['Leden', 'Únor', 'Březen', 'Duben', 'Květen', 'Č']        

firebase.database().ref('/shootings/' + userId)
  .orderByChild('active')
  .limitToLast(1)
  .once('value')
  .then(function(snapshot) {
    if (snapshot.exists()) {
      snapshot.forEach(function(shooting) {
        shootingKey = shooting.key;
        doc = storageRef.child("docs/" + userId + '/' + shootingKey + '/' + $rootScope.activeYear + "/monthly/");
        loadMonthlyPlan();
        initMap();
      });
    }
  });

let loadMonthlyPlan = function() {
  firebase.database().ref('monthlyPlans/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear).once('value').then(function(value) {
    doc.child(pdfname + value.val() + '.pdf').getDownloadURL().then(function(url) {                            
      $scope.docPdf = url;
      $scope.actualPlan = url;
      $scope.showPdf = true; 
      $scope.showLoader = false;   
      $scope.$apply(); 
    }).catch(function(error) {
      let docEmpty = storageRef.child("docs/");
      let doc1 = docEmpty.child("monthlyPlan.pdf").getDownloadURL().then(function(url) {                            
      $scope.docPdf = url;
      $scope.actualPlan = url;
      $scope.showPdf = true; 
      $scope.showLoader = false;   
      $scope.$apply(); 
      }).catch(function(error) {
      });
    });                             
  });
}

//Map

let initMap = function() {
  $scope.poseds = [];
  $scope.krmelecs = [];
  $scope.zasyps = [];
  let tempMarker;
  firebase.database().ref('/shootings/' + userId)
      .orderByChild('active')
      .limitToLast(1)
      .once('value')
      .then(function(snapshot) {
    if (snapshot.exists()) {
      snapshot.forEach(function(childSnapshot) {
        shootingKey = childSnapshot.key;
        $scope.shootingName = childSnapshot.child('name').val();
        $scope.area = childSnapshot.child('area').val();
        $scope.fields = childSnapshot.child('fields').val();
        $scope.water = childSnapshot.child('water').val();
        $scope.others = childSnapshot.child('others').val();
        $scope.woods = childSnapshot.child('woods').val();
        $scope.description = childSnapshot.child('description').val();
        $scope.lat = childSnapshot.child('lat').val();
        $scope.lng = childSnapshot.child('lng').val();

        //TODO: natahnout posedy atd...
        firebase.database().ref('/structures/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear).once('value').then(function(structures) {
          let poseds = structures.child('posed').val();
          let krmelecs = structures.child('krmelec').val();
          let zasyps = structures.child('zasyp').val();

          for (let key in poseds) {            
            $scope.poseds.push(poseds[key]);
          }

          for (let key in krmelecs) {
            $scope.krmelecs.push(krmelecs[key]);
          }

          for (let key in zasyps) {
            $scope.zasyps.push(zasyps[key]);
          }

          $scope.initMap();
        })
      });

      $scope.shootingLabel = "Informace a mapa honitby";
      $scope.shootingModLabel = "Editovat honitbu a stavení >>";
      $scope.disableNextButton = "disabled";
      let map;
      let editMod = false;      
      let markers = [];
      let choosedIcon;
      let choosedType;
      let icons = {
        posed: {
          icon: 'assets/image/posed3.png'
        },
        krmelec: {
          icon: 'assets/image/krmelec3.png'
        }
      };

      let types = {
        krmelec: "krmelec",
        posed: "posed"
      }

      $scope.initMap = function() {
        map = new google.maps.Map(document.getElementById('map-main-view'), {
          center: {lat: $scope.lat, lng: $scope.lng},
          zoom: 10,
          maxZoom: 16
        });     

        $scope.poseds.forEach(function(posed) {
          placeMarker({lat: posed.lat, lng: posed.lng}, map, icons.posed.icon);
        })

        $scope.krmelecs.forEach(function(krmelec) {
          placeMarker({lat: krmelec.lat, lng: krmelec.lng}, map, icons.krmelec.icon);
        })

        $scope.zasyps.forEach(function(zasyps) {
          placeMarker({lat: zasyps.lat, lng: zasyps.lng}, map, icons.posed.icon);
        });       
      }

      function placeMarker(latLng, map, icon) {                        
        var marker = new google.maps.Marker({
          position: latLng,      
          icon: icon,
          map: map
        });
        markers.push(marker);
      }

      $scope.showInfo = true;
      $scope.showEdit = false;
      $scope.hideLoading = true;
      $scope.addStructurePart = false;
      $scope.$apply();
    }
  });
}
});
