MyslDenik.controller("membersController", function($http, $rootScope, $scope, $location, $cookies) {

  let userId = $cookies.getObject('loggedUser').id;
  let newRecordEmpty = {name: '', function: '', phone: null, email: '', date: new Date()};
  let shootingKey;
  let mapRecords = [];
  let init = true;

  $scope.records = [];
  $scope.editArray = [];
  $scope.dates = []; 
  $scope.newRecord = {name: '', function: '', phone: null, email: '', date: ''};

  firebase.database().ref('/shootings/' + userId)
      .orderByChild('active')
      .limitToLast(1)
      .once('value')
      .then(function(snapshot) {
        if (snapshot.exists()) {
          snapshot.forEach(function(shooting) {
            shootingKey = shooting.key;
          });
          let ref = firebase.database().ref('members/' + userId + '/' + shootingKey);
          ref.on('child_added', function(record) {
              $scope.records.push(record.val());              
              mapRecords.push(record); 
              $scope.dates.push(new Date(record.val().date));
              if (init) {
                $scope.$apply();
              }             
          });   
        }       
      });

  let prepareEditArray = function() {
    $scope.records.forEach(function(element) {
        $scope.editArray.push(false);
    }, this);
  }

  $scope.getReadableDate = function(index) {        
    let date = new Date($scope.records[index].date);
    return date.toLocaleDateString("en-US");
  }

  $scope.saveRecord = function(index) {
    if (!$scope.editArray[index]) {
      let stringDate = $scope.dates[index].toString();
      $scope.records[index].date = stringDate;
      let key = mapRecords[index].key
      firebase.database().ref().child('members/' + userId + '/' + shootingKey + key).update($scope.records[index]);
    }
  }

  $scope.getDateX = function(index) {
    return new Date($scope.records[index].date);
  }

  $scope.saveNewRecord = function() {
    init = false;    
    let stringDate = $scope.newRecord.date.toString();
    $scope.newRecord.date = stringDate;
    firebase.database().ref('members/' + userId + '/' + shootingKey).push($scope.newRecord);    
    $scope.newRecord = newRecordEmpty;    
  }

});
