MyslDenik.controller("loginController", function($http, $rootScope, $cookies, $scope, $location) {
  
  init = function(user) {
    var expireDate = new Date();
    expireDate.setDate(expireDate.getDate() + 1);
    $cookies.putObject('loggedUser', {id: user.uid, name: user.displayName},
        {expires: expireDate});
    $rootScope.userName = user.displayName;
    firebase.database().ref('/shootings/' + user.uid)
        .orderByChild('active')
        .limitToLast(1)
        .once('value')
        .then(function(snapshot) {
      if (snapshot.exists()) {
        snapshot.forEach(function(childSnapshot) {
          let year = new Date();  
          $rootScope.activeYear = year.getFullYear();        
          $rootScope.activeShooting = childSnapshot.child('name').val();
          $cookies.putObject('shooting', {name: childSnapshot.child('name').val(),
              id: childSnapshot.key, year: year.getFullYear()}, {expires: expireDate});
          $location.path('/mainView');
          $scope.$apply();
        });
      }
    });
    return true;
  }

	$scope.login = function() {
        // $scope.disableRegistration = true;
        var username = $scope.loginInput;
        var password = $scope.passwordInput;
        // var registrationErrorMsg = "";

        if (!username) {
          $scope.loginErrorMsg = "Zadejte email";
          return;
        }

        if (!password) {
          $scope.loginErrorMsg = "Zadejte heslo";
          return;
        }

        firebase.auth().signInWithEmailAndPassword(username, password)
          .then(function(user){
              if (user.emailVerified) {
                init(user);                
              } else {
                $scope.loginErrorMsg = "Emailová adresa doposud nebyla potvrzena.";
              }
              
          }).catch(function(error) {
              var errorCode = error.code;
              var errorMessage = error.message;
              if (errorCode == "auth/wrong-password") {
                $scope.loginErrorMsg = "Špatně zadané heslo";
                $rootScope.$apply();
              }
              if (errorCode == "auth/user-not-found") {
                $scope.loginErrorMsg = "Účet s tímto emailem neexistuje";
                $rootScope.$apply();
              }
          });
    };

});
