MyslDenik.controller("registrationController", ["$http", "$rootScope", "$scope", "$location", function($http, $rootScope, $scope, $location) {
  $scope.showRegistrationInfo = false;

  $scope.registration = function() {
        // $scope.disableRegistration = true;
        var email = $scope.loginInput;
        var username = $scope.nameInput;
        var password = $scope.passwordInput;
        var passwordAgain = $scope.passwordAgainInput;
        // var registrationErrorMsg = "";

        if (!email) {
          $scope.registrationErrorMsg = "Zadejte email";
          return;
        }

        if (!username) {
          $scope.registrationErrorMsg = "Zadejte Vaše jméno";
          return;
        }

        if (!password) {
          $scope.registrationErrorMsg = "Zadejte heslo";
          return;
        }

        if (!passwordAgain) {
          $scope.registrationErrorMsg = "Zadejte heslo znovu";
          return;
        }

        if (password != passwordAgain) {
          $scope.registrationErrorMsg = "Hesla se musi shodovat";
          return;
        }

        firebase.auth().createUserWithEmailAndPassword(email, password)
          .then(function(user){
              user.updateProfile({
                displayName: username
              }).then(function() {
                console.log("Update v poradku");
                user.sendEmailVerification();
                $scope.showRegistrationInfo = true;
                $rootScope.$apply();
              }, function(error) {
                console.log("Chzyba:" + error);
              });

          }).catch(function(error) {
              $rootScope.$apply();
              var errorCode = error.code;
              var errorMessage = error.message;

              if (errorCode == "auth/weak-password") {
                $scope.registrationErrorMsg = "Heslo musí mít alespoň 6 znaků";
                $rootScope.$apply();
              }
              if (errorCode == "auth/email-already-in-use") {
                $scope.registrationErrorMsg = "Učet s tímto emailem je již používán";
                $rootScope.$apply();
              }
          });


    };

}]);
