MyslDenik.controller("fulfilPlansController", function($http, $rootScope, $scope,  $location, submenuNames, $cookies, $timeout) {
        
    $scope.showPdf = false;    
    $scope.showLoader = true;
    $scope.showPdfInfo = false;
    $scope.docPdf = "";  
    $scope.fileHref = "url";   
    $scope.activeMonth = 1; 
    $scope.monthlyPlanExists = false;
    $scope.activeMonthx = 'black'; 
    $scope.menuTitle = submenuNames($location.path().split("/").pop());    
    let userId = $cookies.getObject('loggedUser').id;    
    let pdfname = "monthlyPlan";        
    let storage = firebase.storage();
    let storageRef = storage.ref();
    let doc = '';  
    let shootingKey = '';     
    // let months = ['Leden', 'Únor', 'Březen', 'Duben', 'Květen', 'Č']        

    firebase.database().ref('/shootings/' + userId)
      .orderByChild('active')
      .limitToLast(1)
      .once('value')
      .then(function(snapshot) {
        if (snapshot.exists()) {
          snapshot.forEach(function(shooting) {
            shootingKey = shooting.key;
            doc = storageRef.child("docs/" + userId + '/' + shootingKey + '/' + $rootScope.activeYear + "/monthly/");
            loadMonthlyPlan();            
          });
        }
      });

    let loadMonthlyPlan = function(index) {
        doc.child(pdfname + index + '.pdf').getDownloadURL().then(function(url) {                
            $scope.docPdf = url;
            $scope.actualPlan = url;
            $scope.showPdf = true; 
            $scope.showLoader = false;
            $scope.monthlyPlanExists = true;
            $scope.$apply();
        }).catch(function(error) {
            firebase.database().ref('monthlyPlans/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear).once('value').then(function(value) {
              doc.child(pdfname + value.val() + '.pdf').getDownloadURL().then(function(url) {                            
                $scope.docPdf = url;
                $scope.actualPlan = url;
                $scope.showPdf = true; 
                $scope.showLoader = false;   
                $scope.$apply(); 
              }).catch(function(error) {
                let docEmpty = storageRef.child("docs/");
                let doc1 = docEmpty.child("monthlyPlan.pdf").getDownloadURL().then(function(url) {                            
                $scope.docPdf = url;
                $scope.actualPlan = url;
                $scope.showPdf = true; 
                $scope.showLoader = false;   
                $scope.$apply(); 
                }).catch(function(error) {
                });
              });  
            })                       
        });
    }

    // loadMonthlyPlan($scope.activeMonth);        


    $scope.buttonStyle = function(month) {
     return (month == $scope.activeMonth);
    }

    $scope.showPlan = function(month) {
      $scope.activeMonth = month;
      loadMonthlyPlan(month);
    }

    $scope.submit = function() {        
      if ($scope.form.file.$valid && $scope.file) {
        $scope.upload($scope.file);
      }
    };

    // upload on file select or drop
    $scope.upload = function (file) {
        $scope.showPdf = false;
        $scope.showLoader = true;
        let mountainImagesRef = doc.child(pdfname + $scope.activeMonth + ".pdf");

        let filex = file // use the Blob or File API
        mountainImagesRef.put(filex).then(function(snapshot) {
            loadMonthlyPlan($scope.activeMonth);
            $scope.showPdfInfo = true;
            $scope.pdfInfo = "Soubor úspěšně nahrán";
            firebase.database().ref('monthlyPlans/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear).set($scope.activeMonth);
            $timeout(function() {
                $scope.showPdfInfo = false;
            }, 5000); 
            $scope.$apply();
        });       
    };
}); 