MyslDenik.controller("planspdfController", function($http, $rootScope, $scope,  $location, submenuNames, $cookies, $timeout) {
        
    $scope.showPdf = false;    
    $scope.showLoader = true;
    $scope.showPdfInfo = false;
    $scope.docPdf = "";  
    $scope.fileHref = "url";    
    $scope.menuTitle = submenuNames($location.path().split("/").pop());    
    let userId = $cookies.getObject('loggedUser').id;    
    let pdfname = $location.path().split("/").pop() + ".pdf";        
    let storage = firebase.storage();
    let storageRef = storage.ref();
    let doc = '';  
    let shootingKey = '';     
    // let months = ['Leden', 'Únor', 'Březen', 'Duben', 'Květen', 'Č']        

    firebase.database().ref('/shootings/' + userId)
      .orderByChild('active')
      .limitToLast(1)
      .once('value')
      .then(function(snapshot) {
        if (snapshot.exists()) {
          snapshot.forEach(function(shooting) {
            shootingKey = shooting.key;
            doc = storageRef.child("docs/" + userId + '/' + shootingKey + '/' + $rootScope.activeYear);
            loadPDF();            
          });
        }
      });       
    
    let loadPDF = function() {
        let doc1 = doc.child(pdfname).getDownloadURL().then(function(url) {                
            $scope.docPdf = url;
            $scope.actualPlan = url;
            $scope.showPdf = true; 
            $scope.showLoader = false;
            $scope.$apply();
        }).catch(function(error) {
            $scope.showLoader = false;
            $scope.showPdfInfo = true;
            $scope.pdfInfo = "Zatím nenahrán žádný plán";
            $scope.$apply();            
        });
    }

    let loadEmptyPdf = function() {
        
        let doc = storageRef.child("docs");
        let doc1 = doc.child(pdfname).getDownloadURL().then(function(url) {                            
            $scope.emptyPlan = url;
            $scope.$apply();
        }).catch(function(error) {
        }); 
    }

    loadEmptyPdf();    

    $scope.submit = function() {        
      if ($scope.form.file.$valid && $scope.file) {
        $scope.upload($scope.file);
      }
    };

    // upload on file select or drop
    $scope.upload = function (file) {
        $scope.showPdf = false;
        $scope.showLoader = true;
        let mountainImagesRef = storageRef.child('docs/' + userId + '/' + shootingKey + '/' + $rootScope.activeYear + '/' + pdfname);

        let filex = file // use the Blob or File API
        mountainImagesRef.put(filex).then(function(snapshot) {
            loadPDF();
            $scope.showPdfInfo = true;
            $scope.pdfInfo = "Soubor úspěšně nahrán";
            $timeout(function() {
                $scope.showPdfInfo = false;
            }, 5000); 
            $scope.$apply();
            console.log('Uploaded a blob or file!');
        });       
    };
}); 