MyslDenik.controller("addNewShootingController",
      function($http, $rootScope, $scope, $location, $cookies, objectFactory) {

  $scope.chooseMapInfo = 'Vyberte kliknutím do mapy přibližný střed Vaší honitby';
  var markers = [];
  var userId = $cookies.getObject('loggedUser').id;
  firebase.database().ref('/shootings/' + userId).once('value')
      .then(function(snapshot) {
    if (!snapshot.exists()) {
      $scope.addNewShootingCheckboxHide = true;
      $scope.addNewShootingActive = true;
    } else {
      $scope.addNewShootingActive = false;
    }
  });

  $scope.initMap = function() {
    var map = new google.maps.Map(document.getElementById('map'), {
      center: {lat: 49, lng: 14},
      zoom: 10
    });
    // var infoWindow = new google.maps.InfoWindow({map: map});

    map.addListener('click', function(e) {
      $scope.chooseMapInfo = 'Střed honitby vybrán';
      placeMarkerAndPanTo(e.latLng, map);
      $scope.$apply();
    });

    // Try HTML5 geolocation.
    if (navigator.geolocation) {
      navigator.geolocation.getCurrentPosition(function(position) {
        var pos = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        };
        // infoWindow.setPosition(pos);
        // infoWindow.setContent('Location found.');
        map.setCenter(pos);
      }, function() {
        handleLocationError(true, infoWindow, map.getCenter());
      });
    } else {
      // Browser doesn't support Geolocation
      handleLocationError(false, infoWindow, map.getCenter());
    }
  }

  function placeMarkerAndPanTo(latLng, map) {
    $scope.addNewShootingLat = latLng.lat();
    $scope.addNewShootingLng = latLng.lng();
    deleteMarkers();
    var marker = new google.maps.Marker({
      position: latLng,      
      map: map
    });
    markers.push(marker);
    map.panTo(latLng);

  }

  function handleLocationError(browserHasGeolocation, infoWindow, pos) {
    infoWindow.setPosition(pos);
    infoWindow.setContent(browserHasGeolocation ?
                          'Error: The Geolocation service failed.' :
                          'Error: Your browser doesn\'t support geolocation.');
  }

  function setMapOnAll(map) {
    for (var i = 0; i < markers.length; i++) {
      markers[i].setMap(map);
    }
  }

  // Removes the markers from the map, but keeps them in the array.
  function clearMarkers() {
    setMapOnAll(null);
  }

  // Deletes all markers in the array by removing references to them.
  function deleteMarkers() {
    clearMarkers();
    markers = [];
  }

  $scope.initMap();

  function checkValues() {
    if (typeof $scope.addNewShootingName === 'undefined') {
      $scope.errorMsg = 'Zadejte jméno honitby';
      return false;
    }

    if (typeof $scope.addNewShootingLat === 'undefined') {
      $scope.errorMsg = 'Vyberte kliknutím do mapy přibližný střed honitby';
      return false;
    }

    return true;
  }

  $scope.addNewShooting = function() {
    if (!checkValues()) {
      return;
    }

    var userUid = firebase.auth().currentUser.uid;
    var newPostKey = firebase.database().ref().child('shootings').push().key;
    var newShooting = new objectFactory.getShooting($scope.addNewShootingName,
        $scope.addNewShootingArea, $scope.addNewShootingFields, $scope.addNewShootingWoods,
        $scope.addNewShootingWater, $scope.addNewShootingOthers, $scope.addNewShootingDescription,
        $scope.addNewShootingActive, $scope.addNewShootingLat, $scope.addNewShootingLng);

    firebase.database().ref('shootings/' + userUid + '/' + newPostKey).set(newShooting);

    if ($scope.addNewShootingActive) {
      var expireDate = new Date();

      if (typeof $cookies.getObject('shooting') !== 'undefined') {
        var lastActiveShootingId = $cookies.getObject('shooting').id;
        firebase.database().ref('shootings/' + userUid + '/' + lastActiveShootingId).update({
          'active': false
        });
      }

      expireDate.setDate(expireDate.getDate() + 1);
      $cookies.putObject('shooting', {name: $scope.addNewShootingName, id: newPostKey},
          {expires: expireDate});
      $rootScope.activeShooting = $scope.addNewShootingName;
    }

    $location.path('/shootingMap');

  };
});
