MyslDenik.controller("shootingMapController", function($http, $rootScope, $scope, $location, $cookies, objectFactory) {
  
  $scope.newStructure = {name: '', note: ''};  
  let userId = $cookies.getObject('loggedUser').id;
  let shootingKey = '';
  let shooting;
  $scope.poseds = [];
  $scope.krmelecs = [];
  $scope.zasyps = [];
  let tempMarker;
  firebase.database().ref('/shootings/' + userId)
      .orderByChild('active')
      .limitToLast(1)
      .once('value')
      .then(function(snapshot) {
    if (snapshot.exists()) {
      snapshot.forEach(function(childSnapshot) {
        shootingKey = childSnapshot.key;
        $scope.shootingName = childSnapshot.child('name').val();
        $scope.area = childSnapshot.child('area').val();
        $scope.fields = childSnapshot.child('fields').val();
        $scope.water = childSnapshot.child('water').val();
        $scope.others = childSnapshot.child('others').val();
        $scope.woods = childSnapshot.child('woods').val();
        $scope.description = childSnapshot.child('description').val();
        $scope.lat = childSnapshot.child('lat').val();
        $scope.lng = childSnapshot.child('lng').val();
        
        //TODO: natahnout posedy atd...
        firebase.database().ref('/structures/' + userId + '/' + shootingKey).once('value').then(function(structures) {
          let poseds = structures.child('posed').val();
          let krmelecs = structures.child('krmelec').val();
          let zasyps = structures.child('zasyp').val();

          for (let key in poseds) {            
            $scope.poseds.push(poseds[key]);
          }

          for (let key in krmelecs) {
            $scope.krmelecs.push(krmelecs[key]);
          }

          for (let key in zasyps) {
            $scope.zasyps.push(zasyps[key]);
          }

          $scope.initMap();
        })
      });

      $scope.shootingLabel = "Informace a mapa honitby";
      $scope.shootingModLabel = "Editovat honitbu a stavení >>";
      $scope.disableNextButton = "disabled";
      var map;
      let editMod = false;      
      let markers = [];
      let choosedIcon;
      let choosedType;
      let icons = {
        posed: {
          icon: 'assets/image/posed3.png'
        },
        krmelec: {
          icon: 'assets/image/krmelec3.png'
        }
      };

      let types = {
        krmelec: "krmelec",
        posed: "posed"
      }

      $scope.initMap = function() {
        map = new google.maps.Map(document.getElementById('map'), {
          center: {lat: $scope.lat, lng: $scope.lng},
          zoom: 10,
          maxZoom: 16
        });     

        map.addListener('click', function(e) {          
          if (choosedIcon) {                        
            $scope.disableNextButton = "";
            placeNewMarker(e.latLng, map, choosedIcon);
            $scope.$apply();
          }
        });

        $scope.poseds.forEach(function(posed) {
          placeMarker({lat: posed.lat, lng: posed.lng}, map, icons.posed.icon, posed.name);
        })

        $scope.krmelecs.forEach(function(krmelec) {
          placeMarker({lat: krmelec.lat, lng: krmelec.lng}, map, icons.krmelec.icon, krmelec.name);
        })

        $scope.zasyps.forEach(function(zasyps) {
          placeMarker({lat: zasyps.lat, lng: zasyps.lng}, map, icons.posed.icon, zasyps.name);
        })
        // var marker = new google.maps.Marker({
        //   position: {lat: $scope.lat, lng: $scope.lng},
        //   map: map
        // });       

      }
      

      function placeNewMarker(latLng, map, icon) {
        if (tempMarker) {
          tempMarker.setMap(null);
        }
        $scope.newStructureLat = latLng.lat();
        $scope.newStructureLng = latLng.lng();
        tempMarker = new google.maps.Marker({
          position: latLng,      
          icon: icon,
          map: map
        });  
      }

      function placeMarker(latLng, map, icon, label) {                        
        var marker = new google.maps.Marker({
          position: latLng,      
          icon: icon,        
          map: map
        });

        let infoWindow = new google.maps.InfoWindow({
          content: label
        });

        marker.addListener('click', function() {
          infoWindow.open(map, marker);
        });
        markers.push(marker);
      }

    function setMapOnAll(map) {
      for (var i = 0; i < markers.length; i++) {
        markers[i].setMap(map);
      }
    }
      // Removes the markers from the map, but keeps them in the array.
    function clearMarkers() {
      setMapOnAll(null);
    }

    // Deletes all markers in the array by removing references to them.
    function deleteMarkers() {
      clearMarkers();
      markers = [];
    }

      $scope.addPosed = function() {
        // map.setOptions({ draggableCursor: 'url('+ icons.posed.icon +'), auto' });
        map.setOptions({ draggableCursor: 'crosshair' });
        choosedIcon = icons.posed.icon;   
        choosedType = types.posed;   
        $scope.addStructurePart = true;
        
      }

      $scope.addKrmelec = function() {
        // map.setOptions({ draggableCursor: 'url('+ icons.krmelec.icon +'), crosshair' });
        map.setOptions({ draggableCursor: 'crosshair' });
        choosedIcon = icons.krmelec.icon;
        choosedType = types.krmelec;
        $scope.addStructurePart = true;
        
      }

      $scope.addStructure = function() {
        if(typeof(newItemLat) !== undefined) {         
          let newStructure = new objectFactory.getStructure($scope.newStructure.name, 
              $scope.newStructure.note, $scope.newStructureLat, $scope.newStructureLng);

          firebase.database().ref('structures/' + userId + '/' + shootingKey + '/' + choosedType).push(newStructure);
          let newMarker = Object.assign({}, tempMarker);
          markers.push(newMarker);
          tempMarker.setMap(null);
          $scope.trashStructure();
        }
      }

      $scope.trashStructure = function() {
        $scope.newStructure = {name: '', note: ''};
        $scope.addStructurePart = false;
        $scope.addStructurePartTwo = false;
        tempMarker.setMap(null);
        choosedIcon = null;
        map.setOptions({ draggableCursor: '' });
      }

      $scope.addStructureNextStep = function() {
        $scope.addStructurePartTwo = true;
      }

      $scope.switchShootingMod = function() {    
        editMod = !editMod;
        $scope.showInfo = !$scope.showInfo;
        $scope.showEdit = !$scope.showEdit;        
        if (editMod) {               
          $scope.shootingLabel = "Úprava honitby";
          $scope.shootingModLabel = "<< Ukončit editační mod";
        } else {          
          $scope.shootingLabel = "Informace a mapa honitby";
          $scope.shootingModLabel = "Editovat honitbu a stavení >>";
          $scope.addStructurePart = false;
          $scope.addStructurePartTwo = false;          
          $scope.disableNextButton = "disabled"; 
          choosedIcon = null;  
          map.setOptions({ draggableCursor: '' });       
        }
        
        // $scope.$apply();  
      }
      
      $scope.showInfo = true;
      $scope.showEdit = false;
      $scope.hideLoading = true;
      $scope.addStructurePart = false;
      $scope.$apply();
    }
  });

  $scope.saveChanges = function() {
    shooting = new objectFactory.getShooting($scope.shootingName, $scope.area, $scope.fields, $scope.woods,
            $scope.water, $scope.others, $scope.description, true, $scope.lat, $scope.lng);
    console.dir(shooting);
    firebase.database().ref('shootings/' + userId + '/' + shootingKey).update(shooting).then(function(result) {
      $scope.switchShootingMod();
      $scope.$apply();
    });
  }

});
